// MainListView.cpp : implementation file
//

#include "stdafx.h"
#include "MDILayout.h"

#include "MDILayoutDoc.h"
#include "MainListView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainListView

IMPLEMENT_DYNCREATE(CMainListView, CListView)

BEGIN_MESSAGE_MAP(CMainListView, CListView)
	//{{AFX_MSG_MAP(CMainListView)
	ON_NOTIFY_REFLECT(LVN_ITEMCHANGED, OnItemchanged)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CListView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CListView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CListView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMainListView construction/destruction

CMainListView::CMainListView() : m_List(GetListCtrl())
{

}
CMainListView::~CMainListView()
{
}

/////////////////////////////////////////////////////////////////////////////
// CMainListView drawing

void CMainListView::OnDraw(CDC* pDC)
{
	CMDILayoutDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: add draw code for native data here
}

void CMainListView::OnInitialUpdate()
{
	CListView::OnInitialUpdate();

	m_List.SetExtendedStyle(LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES);
	ModifyStyle(LVS_TYPEMASK, LVS_REPORT);


	CString csItem;
	for(int iIndx = 0; iIndx < 3; iIndx++)
	{
		csItem.Format("Col %.2d", iIndx);
		m_List.InsertColumn(iIndx, csItem, LVCFMT_LEFT, 120);
	}
	
	for(/*int */iIndx = 0; iIndx < 7; iIndx++)
	{
		csItem.Format("Item %.2d", iIndx);
		m_List.InsertItem(iIndx, csItem);
		
		for(int jIndx = 1; jIndx < 3; jIndx++)
		{
			csItem.Format("SubItem %.2d%.2d", iIndx, jIndx);
			m_List.SetItemText(iIndx, jIndx, csItem);
			
		}
	}
}

/////////////////////////////////////////////////////////////////////////////
// CMainListView printing

BOOL CMainListView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CMainListView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CMainListView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CMainListView diagnostics

#ifdef _DEBUG
void CMainListView::AssertValid() const
{
	CListView::AssertValid();
}

void CMainListView::Dump(CDumpContext& dc) const
{
	CListView::Dump(dc);
}

CMDILayoutDoc* CMainListView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CMDILayoutDoc)));
	return (CMDILayoutDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainListView message handlers

void CMainListView::OnItemchanged(NMHDR* pNMHDR, LRESULT* pResult) 
{
	HD_NOTIFY *phdn = (HD_NOTIFY *) pNMHDR;
	POSITION pos = m_List.GetFirstSelectedItemPosition();

	*pResult = 0;

	int iIndex = m_List.GetNextSelectedItem(pos); // only one selected

	if(iIndex < 0)
	{
		return;
	}

	CMDILayoutDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	pDoc->m_csItemText = m_List.GetItemText(iIndex, 0);

	pDoc->m_csSubitemText[0] = m_List.GetItemText(iIndex, 1);
	pDoc->m_csSubitemText[1] = m_List.GetItemText(iIndex, 2);

	pDoc->UpdateAllViews(this);
	
}
