// TitleFormView.cpp : implementation file
//

#include "stdafx.h"
#include "MDILayout.h"

#include "MDILayoutDoc.h"
#include "TitleFormView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTitleFormView

IMPLEMENT_DYNCREATE(CTitleFormView, CFormView)

BEGIN_MESSAGE_MAP(CTitleFormView, CFormView)
	//{{AFX_MSG_MAP(CTitleFormView)
	ON_WM_SIZE()
	ON_WM_CREATE()
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CFormView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CFormView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CFormView::OnFilePrintPreview)
	ON_MESSAGE(WM_SIZEPARENT, OnSizeParent)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTitleFormView construction/destruction

CTitleFormView::CTitleFormView()
	: CFormView(CTitleFormView::IDD)
	, m_uiCYDefault(NULL)
{
	//{{AFX_DATA_INIT(CTitleFormView)
	m_csTitle = _T("Title");
	//}}AFX_DATA_INIT
	// TODO: add construction code here

}

CTitleFormView::~CTitleFormView()
{
}

void CTitleFormView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTitleFormView)
	DDX_Control(pDX, IDC_STATIC_TITLE, m_staticTitle);
	DDX_Text(pDX, IDC_STATIC_TITLE, m_csTitle);
	//}}AFX_DATA_MAP
}

/////////////////////////////////////////////////////////////////////////////
// CTitleFormView printing

BOOL CTitleFormView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CTitleFormView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CTitleFormView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

void CTitleFormView::OnPrint(CDC* pDC, CPrintInfo* /*pInfo*/)
{
	// TODO: add customized printing code here
}

/////////////////////////////////////////////////////////////////////////////
// CTitleFormView diagnostics

#ifdef _DEBUG
void CTitleFormView::AssertValid() const
{
	CFormView::AssertValid();
}

void CTitleFormView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CMDILayoutDoc* CTitleFormView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CMDILayoutDoc)));
	return (CMDILayoutDoc*)m_pDocument;
}
#endif //_DEBUG

LRESULT CTitleFormView::OnSizeParent(WPARAM wParam, LPARAM lParam)
{
	AFX_SIZEPARENTPARAMS* lpLayout = (AFX_SIZEPARENTPARAMS*)lParam;
	
	CRect rectClient(lpLayout->rect);
	/**** JohnCz ***/
	// position at the top
	rectClient.bottom = rectClient.top + m_uiCYDefault;
	
	// and half width flushed to the right
	rectClient.left = rectClient.right - rectClient.Width() / 2;


	/**** JohnCz ***/
	// adjust layout; secont pane will position in the same half
	// lpLayout->sizeTotal will show second pane where to position itself. 
	lpLayout->rect.top = rectClient.bottom;
	lpLayout->rect.right = rectClient.left;
	lpLayout->sizeTotal = rectClient.Size();
	
	if (lpLayout->hDWP != NULL)
		AfxRepositionWindow(lpLayout, m_hWnd, &rectClient);
	
	return 0;
}

/////////////////////////////////////////////////////////////////////////////
// CTitleFormView message handlers

void CTitleFormView::OnSize(UINT nType, int cx, int cy) 
{
	CFormView::OnSize(nType, cx, cy);
	
	if(IsWindow(m_staticTitle))
	{
		m_staticTitle.MoveWindow(0, 0, cx, cy);
	}
	
}

int CTitleFormView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CFormView::OnCreate(lpCreateStruct) == -1)
		return -1;
	

	CRect rectWnd;
	GetWindowRect(rectWnd);
	m_uiCYDefault = rectWnd.Height();
	rectWnd.SetRectEmpty();

	MoveWindow(rectWnd);


	return 0;
}

void CTitleFormView::OnInitialUpdate() 
{
	CFormView::OnInitialUpdate();
	
	GetParentFrame()->RecalcLayout();

	CRect rectClient;
	GetClientRect(rectClient);

	m_staticTitle.MoveWindow(rectClient);
	
}

void CTitleFormView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint) 
{
	CMDILayoutDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	if(pDoc->m_csItemText.IsEmpty())
	{
		return;
	}

	m_csTitle = pDoc->m_csItemText;

	UpdateData(FALSE);
}
